#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

/*  Print out the (time_t) mtime of the most recently modified file
 *  specified on the command line.
 */

main(int argc, char *argv[])
{
  int i;
  struct stat buf;
  struct tm *t;
  time_t tt = -1;
  char *latest = NULL, s[256];

  /* Loop through the arguments to find the youngest. */

  for (i = 1; i < argc; i++) {

    if (stat(argv[i], &buf) == 0)	/* get buffer describing the file  */
      if (buf.st_mtime > tt) {
	tt = buf.st_mtime;
	latest = argv[i];
      }
  }

  if (latest) {
    printf("%d\n", tt);

#if 0
    stat(latest, &buf);
    t = localtime(&buf.st_mtime);	/* convert modification time to tm */
    strftime(s, 256,
	     "%A, %B %Y, %T", t);	/* format the time as desired      */
    printf("%s: %d %s\n", latest, buf.st_mtime, s);
#endif

  } else
    printf("-1\n");
}
