
c     
c     Copyright (c) 1986,1987,1988,1989,1990,1991,1992,1993,
c     by Steve McMillan, Drexel University, Philadelphia, PA.
c     
c     All rights reserved.
c     
c     Redistribution and use in source and binary forms are permitted
c     provided that the above copyright notice and this paragraph are
c     duplicated in all such forms and that any documentation,
c     advertising materials, and other materials related to such
c     distribution and use acknowledge that the software was developed
c     by the author named above.
c     
c     THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
c     IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
c     WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
c     
      subroutine fr lnxdr(y,x1,x2,dxs,dxm,dxl,iax,ilab,nlab,ndec)
      save
c     
c     Draw x-axis, tick marks and numbers for linear case (ndec nonzero),
c     and major tick marks and numbers for the logarithmic case (ndec = 0).
c     
c     No numbers are drawn for nonzero lmode.
c     
      dimension dx(3)
      common/scales/xl,xr,dinchx,ybot,ytop,dinchy,rlen,slen
      common/dev status/idevon,idevpen,idevwt
      common/fr hts/htl,htn/fr wts/iwts(4)
      common/fr ticks/tiks(3),tikl
      common/fr xnums/xnumbot
c     
      common/fr lbx/lmode
      common/fr tik level/jtik level
      data mode/1/jtik level/1/
c     
      data theta/0./
c     
      cinch(xa,xs,di)=(xa-xs)*di
c     
      dx(1)=dxs
      dx(2)=dxm
      dx(3)=dxl
      sax=cinch(y,ybot,dinchy)
      r1=cinch(x1,xl,dinchx)
      r2=cinch(x2,xl,dinchx)
c     
      if (iwts(1).gt.0) then
          jwt=idevwt
          call weight(iwts(1))
      end if
c     
      call plot(r1,sax,3)
      call plot(r2,sax,2)
c     
      ds=1.
      if (iax.eq.2) ds=-1.
c     
c     Draw the tick marks: j = 1, 2, 3 correspond to small, medium and
c     large tick marks, respectively.  Tick sizes are set in eframe.
c     
      do j=jtik level,3
          if (dx(j).ne.0) then
              stik=sax+ds*tiks(j)
              call fr lnfnc(x1,x2,dx(j),mode,firstx,nx)
              dr=dx(j)*dinchx
              r=cinch(firstx,xl,dinchx)
              do i=1,nx
                  call plot(r,sax,3)
                  call plot(r,stik,2)
                  r=r+dr
              end do
          end if
      end do
c     
      if (iwts(1).gt.0) call weight(jwt)
      if (ilab.eq.0.or.lmode.ne.0) return
c     
c     Now add the numbers.
c     
      wid=.85*htn*(nlab+.5)
c     (The nominal width of the number string.)
c     
c     Reduce the scale if the estimated size is too great.
c     
      if (wid.gt.dr) htn=htn*dr/wid
c     
c     Determine placement above or below the axis...
c     
      x=firstx
      r=cinch(firstx,xl,dinchx)
      if (ndec.ne.0)then
          if (iax.eq.1)s=sax-1.1*htn
          if (iax.eq.2)s=sax+1.1*htn
      else
          r=r-.5*htn*nlab
          if (iax.eq.1)s=sax-1.75*htn
          if (iax.eq.2)s=sax+.5*htn
      end if
c     
c     ...and update the data on the bottom of the number field.
c     
      if (iax.eq.1)then
          xnumbot=s
          if (ndec.ne.0)xnumbot=xnumbot-.5*htn
      end if
c     
      if (iwts(2).gt.0)then
          jwt=idevwt
          call weight(iwts(2))
      end if
c     
c     Plot the numbers.
c     
      do i=1,nx
          if (ndec.eq.0) call lognum(r,s,htn,x,theta,-1)
          if (ndec.ne.0) call fr numbr(r,s,htn,x,theta,ndec)
          r=r+dr
          x=x+dxl
      end do
c     
      if (iwts(2).gt.0) call weight(jwt)
c     
      end
